#pragma once

#include <map>
#include <memory>

namespace cpprtti
{

    using type_id = size_t;

    /**
     * @brief Get the ID of a certain C++ type.
     */
    template<typename X>
    inline type_id get_type_id();

    /**
     * @brief Get the name of a certain C++ type.
     */
    template<typename X>
    inline const std::string& get_type_name();

}

#include "helper.inl"
