#pragma once

#include <cxxabi.h>

#include "helper.h"

namespace cpprtti
{

    namespace __impl
    {

        inline type_id create_type_id()
        {
            static type_id value { };
            return ++value;
        }

        template<typename X>
        inline std::string create_type_name()
        {
            int status;
            auto name = abi::__cxa_demangle(typeid(X).name(), nullptr, nullptr, &status);
            return std::string(name ? name : typeid(X).name());
        }

    }

    template<typename X>
    type_id get_type_id()
    {
        static const auto value = __impl::create_type_id();
        return value;
    }

    template<typename X>
    const std::string& get_type_name()
    {
        static const auto value = __impl::create_type_name<X>();
        return value;
    }

}
