#pragma once

#include "type.h"

namespace cpprtti
{

    /* type */

    type::type(
        cpprtti::registry&  p_registry,
        size_t              p_id,
        const std::string&  p_name,
        rtti_type_t         p_rtti_type)
        : _registry (p_registry)
        , _id       (p_id)
        , _name     (p_name)
        , _rtti_type(p_rtti_type)
        { }

    cpprtti::registry& type::registry()
        { return _registry; }

    const cpprtti::registry& type::registry() const
        { return _registry; }

    type_id type::id() const
        { return _id; }

    const std::string& type::name() const
        { return _name; }

    rtti_type_t type::rtti_type() const
        { return _rtti_type; }

}
